#include<bits/stdc++.h>

using namespace std;
typedef pair<double, double> pdd;
typedef pair<double, int> pdi;
typedef pair<int, int> pii;

#define PB push_back
#define ST first
#define ND second

const int maxn = 1e5+100;
vector<int> v[maxn];
set<pii> s;
int vis[maxn];
int n;

void dfs(int a) {
    vis[a] = 2;
    for(int b : v[a]) {
        if(vis[b] == 1) {
            dfs(b);
        }
    }
}

void queryBig(vector<int> &h) {
    for(int i=1; i <= n; i++) {
        vis[i] = 0;
    }
    for(int b : h) {
        vis[b] = 1;
    }
    int res=0;
    for(int b : h) {
        if(vis[b] == 1) {
            dfs(b);
            res++;
        }
    }
    // cout << "Big\n";
    cout << res << "\n";
}

void dfs1(int a, vector<vector<int>> &g, vector<int> &val) {
    val[a] = 2;
    for(int b : g[a]) {
        if(val[b] == 1) {
            dfs1(b, g, val);
        }
    }
}

void querySmall(vector<int> &h) {
    vector<vector<int>> g (h.size());
    vector<int> val (h.size());
    for(int i=0; i < h.size(); i++) {
        for(int j=0; j < i; j++) {
            int a = h[i];
            int b = h[j];
            if(b < a) {
                swap(a, b);
            }
            if(s.count({a, b})) {
                g[i].PB(j);
                g[j].PB(i);
            }
        }
    }
    for(int b=0; b < h.size(); b++) {
        val[b] = 1;
    }
    int res=0;
    for(int b=0; b < h.size(); b++) {
        if(val[b] == 1) {
            dfs1(b, g, val);
            res++;
        }
    }
    cout << res << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    int m, q;
    cin >> n >> m >> q;
    int ns = sqrt(n)/3;
    for(int i=0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        v[a].PB(b);
        v[b].PB(a);
        if(b < a) {
            swap(a, b);
        }
        s.insert({a, b});
    }
    for(int i=0; i < q; i++) {
        int k;
        cin >> k;
        vector<int> g;
        for(int j=0; j < k; j++) {
            int a;
            cin >> a;
            g.PB(a);
        }
        if(k > ns) {
            queryBig(g);
        } else {
            querySmall(g);
        }
    }
}